﻿Imports System.Threading
Imports DotNetBrowser
Imports ProxyInterfaces

Public Class BrowserProxy
    Implements IBrowserProxy

    Dim ReadOnly browser As Browser
    Dim ReadOnly pageLoadEvent As ManualResetEvent

    Public Sub New()
        browser = BrowserFactory.Create()
        AddHandler browser.FinishLoadingFrameEvent, Sub(sender, e)
            If (e.IsMainFrame) Then
                pageLoadEvent.Set()
            End If
        End Sub
        pageLoadEvent = new ManualResetEvent(false)
    End Sub

    Public Function GetWebPageHtml(url As String) As String Implements IBrowserProxy.GetWebPageHtml
        pageLoadEvent.Reset()
        browser.LoadURL(url)
        pageLoadEvent.WaitOne()
        return browser.GetHTML()
    End Function

    Public Sub Dispose() Implements IDisposable.Dispose
        browser?.Dispose()
    End Sub
End Class