﻿Imports System.IO
Imports System.Reflection
Imports ProxyInterfaces

Module Module1
    Sub Main()
        Dim proxy As IBrowserProxy = 
                GetProxyFromAssembly("../../../DotNetBrowserProxy/bin/Debug/DotNetBrowserProxy.dll")
        Dim githubHtml As String = proxy.GetWebPageHtml("github.com")
        Console.WriteLine(githubHtml)

        proxy.Dispose()

        Console.ReadKey()
    End Sub

    Private Function GetProxyFromAssembly(assemblyFileName As String) As IBrowserProxy
        If File.Exists(assemblyFileName) Then
            Dim proxyAssembly As Assembly = Assembly.LoadFrom(assemblyFileName)
            Dim browserProxyType As Type =
                    proxyAssembly.GetTypes().FirstOrDefault(
                        Function(type) type.IsClass AndAlso type.GetInterface("IBrowserProxy") IsNot Nothing)
            If browserProxyType IsNot Nothing Then
                Dim proxy = CType(Activator.CreateInstance(browserProxyType), IBrowserProxy)
                Return proxy
            End If
        End If
        Return Nothing
    End Function
End Module
